﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	Private btnSend As B4XView
	Private btnConnect As B4XView
	Private connected As Boolean
	Private client As Socket
	Public server As ServerSocket
	Private astream As AsyncStreams
	Private const PORT As Int = 51041
	Private lblStatus As B4XView
	Private lblMyIp As B4XView
	Private txtIP As B4XFloatTextField
	Private txtName As B4XFloatTextField
	Private txtAge As B4XFloatTextField

	Public const EOL As String = Chr(13) & Chr(10)
	Public charset As String = "UTF8"
	Private sb As StringBuilder
	sb.Initialize
End Sub

'You can add more parameters here.
Public Sub Initialize

End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	'load the layout to Root
	Root.LoadLayout("1")
	B4XPages.SetTitle(Me, "Test Socket Client")
	For Each txt As B4XFloatTextField In Array(txtIP, txtName, txtAge)
		txt.LargeLabelTextSize = 15
		txt.SmallLabelTextSize = 12
		txt.Update
	Next
	UpdateState(False)
End Sub

Sub B4XPage_Resize (Width As Int, Height As Int)
	'
End Sub

Sub CloseExistingConnection
	If astream.IsInitialized Then astream.Close
	If client.IsInitialized Then client.Close
	UpdateState (False)
End Sub

Sub AStreams_Error
	CloseExistingConnection
End Sub

Sub AStreams_Terminated
	CloseExistingConnection
End Sub

Sub EventName_Connected (Successful As Boolean)
	
End Sub

Sub UpdateState (NewState As Boolean)
	connected = NewState
	btnSend.Enabled = connected
	If connected Then
		btnConnect.Text = "Disconnect"
		lblStatus.Text = "Connected"
	Else
		btnConnect.Text = "Connect"
		lblStatus.Text = "Disconnected"
	End If
	lblMyIp.Text = "My ip: " & server.GetMyIP
End Sub

Private Sub NewText(text As String)
	Log($"Received: ${text}"$)
End Sub

Private Sub astreams_NewData (Buffer() As Byte)
	sb.Append(BytesToString(Buffer, 0, Buffer.Length, charset))
	Dim s As String = sb.ToString
	Dim i As Int = 2
	Dim idx As Int = s.LastIndexOf($"${Chr(13)}${Chr(10)}"$)
	If idx = -1 Then
		i = 1
		idx = s.LastIndexOf($"${Chr(10)}"$)
		If idx = -1 Then idx = s.LastIndexOf($"${Chr(13)}"$)
	End If
	If idx = -1 Then Return
	CallSubDelayed2(Me, "NewText", s.SubString2(0, idx))
	sb.Remove(0, idx + i)
End Sub

Private Sub ConnectToServer(Host As String)
	Log("Trying to connect to: " & Host)
	CloseExistingConnection
	Dim client As Socket
	client.Initialize("client")
	client.Connect(Host, PORT, 10000)
	Wait For Client_Connected (Successful As Boolean)
	If Successful Then
		astream.Initialize(client.InputStream, client.OutputStream, "astreams")
		UpdateState (True)
	Else
		Log("Failed to connect: " & LastException)
	End If
End Sub

Private Sub Disconnect
	CloseExistingConnection
End Sub


Public Sub SendMessage (message As String)
	If connected Then astream.Write($"${message}${EOL}"$.As(String).GetBytes(charset))
End Sub

Sub btnConnect_Click
	If connected = False Then
		If txtIP.Text.Length = 0 Then
			xui.MsgboxAsync("Please enter the server ip address.", "")
			Return
		Else
			ConnectToServer(txtIP.Text)
		End If
	Else
		Disconnect
	End If
End Sub

Sub btnSend_Click
	Dim Age As Int
	If IsNumber(txtAge.Text) Then Age = txtAge.Text Else Age = 0
	SendMessage ($"${txtName.Text} is ${Age} year(s) old"$)
End Sub

Sub btnClear_Click
	txtAge.Text = ""
	txtName.Text = ""
End Sub